package exceptions;

public class MatrixException extends Exception {
	
	private int width;
	private int row;
	private int height;
	private int column;
	
	public MatrixException(int width, int height){
		this.width = width;
		this.height = height;
	}
	
	public MatrixException(int width, int row, int height, int column){
		this.width = width;
		this.height = height;
		this.row = row;
		this.column = column;
	}
	
	@Override
	public String toString(){
		return "\nError: The matrix has an incorrect number of columns or rows\n" +
				"The number of rows must equal the number of columns \n" +
				"Rows: "+this.width+" Columns: "+this.height +
				"Please check your matrix and try again\n";
	}
	
	public String requestError() {
		return "\nError: Requesting a row or column not presnt in the matrix\n" +
				"Requested row: "+this.row+", actual number of rows: "+this.height+"\n" +
				"Requested column: "+this.column+", actual number of columns: "+this.column+"" +
				"Please check your matrix and try again\n";
	}

}
