package io;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import exceptions.MatrixException;

import units.Matrix;

public class MatrixParser {

	private String fileName;
	private ArrayList<Double> values;
	private int columns;
	private int rows = 0;
	
	public MatrixParser(String fileName){
		this.fileName = fileName;
		this.values = new ArrayList<Double>();
	}
	
	public Matrix parse(){
		try{
			BufferedReader reader = new BufferedReader(new FileReader(this.fileName));
			String line = null;
			while((line = reader.readLine()) !=null){
				String[] split = line.split("\\s");
				columns = split.length;
				for(int i=0; i< split.length; i++){
					values.add(Double.parseDouble(split[i]));
				}
				rows++;
			}
		}catch (IOException e) {
			System.out.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
		try{
			testInput(rows, columns);
		}catch(MatrixException e){
			System.err.println(e.toString());
			e.printStackTrace();
			System.exit(1);
		}
		Matrix matrix = new Matrix(columns, rows, values);
		return matrix;
	}
	
	private void testInput(int rows, int columns) throws MatrixException{
		if(rows != columns){
			throw new MatrixException(columns, rows);
		}
	}
}
