package units;

import java.util.ArrayList;

import exceptions.MatrixException;

public class Matrix {

	private int width, height;
	private ArrayList<Double> values;
	
	public Matrix(int width, int height, ArrayList<Double> values){
		this.width = width;
		this.height = height;
		this.values = values;
	}
	
	public int getWidth(){
		return width;
	}
	
	public int getHeight(){
		return height;
	}
	
	public int getLength(){
		return width;
	}
	
	public double get(int row, int column){
		try{
			testInput(row, column);
		}catch(MatrixException e){
			System.err.println(e.requestError());
			e.printStackTrace();
			System.exit(1);
		}
		int index = row * width + column;
		return values.get(index);
	}
	
	private void testInput(int row, int column) throws MatrixException{
		if(row < 0 || row > height-1){
			throw new MatrixException(this.width, row, this.height, column);
		}
		if(column < 0 || column > width-1){
			throw new MatrixException(this.width, row, this.height, column);
		}
	}
}
